#!/bin/bash

#"grep run-parts /etc/crontab" to find cron.hourly time

LOCK_FILE=/home/muxlab/Desktop/scheduled_hour.lock

#check lockfile
if [ -f "$LOCK_FILE" ]; then
    echo "$0> Lock file exists. Performing cleanup..."    
    rm -f "$LOCK_FILE"
    exit 1
fi

#functions
exit_with_error(){
    rm -f "$LOCK_FILE"
    echo ""
    echo "$0> Error."
    exit 1
}

#get app setting for scheduled hour
CURRENTHOUR="$(date +%-H)"
SCHEDULEDHOUR="$(/usr/bin/mysql -u root -e "SELECT AppValue FROM \`muxlabnetworkcontroller_dev_db\`.\`applicationsettings\` WHERE AppProperty='scheduled_hour' \\G" | /bin/grep "AppValue:")"
SCHEDULEDHOUR=${SCHEDULEDHOUR//"AppValue: "/}

#CURRENTHOUR=23
#SCHEDULEDHOUR=23

if [ "$SCHEDULEDHOUR" -eq "$SCHEDULEDHOUR" ] 2>/dev/null; then
    echo "SCHEDULEDHOUR : is a number" 

    if ((SCHEDULEDHOUR >= 0 && SCHEDULEDHOUR <= 23)); then
        echo "SCHEDULEDHOUR : in range"
    else
        echo "SCHEDULEDHOUR : not in range (0-23)"
        exit_with_error
    fi

else
    echo "SCHEDULEDHOUR : not a number"
    exit_with_error
fi


echo "CURRENT HOUR: $CURRENTHOUR"
echo "SCHEDULED HOUR: $SCHEDULEDHOUR"

#check if time match

if ((CURRENTHOUR == SCHEDULEDHOUR)); then
    echo "CURRENT == SCHED"
else
    echo "CURRENTHOUR : Not on time"
    exit_with_error
fi

#get username/password
API_USERNAME="$(/usr/bin/mysql -u root -e "SELECT AppValue FROM \`muxlabnetworkcontroller_dev_db\`.\`applicationsettings\` WHERE AppProperty='api_username' \\G" | /bin/grep "AppValue:")"
API_USERNAME=${API_USERNAME//"AppValue: "/}

API_PASSWORD="$(/usr/bin/mysql -u root -e "SELECT AppValue FROM \`muxlabnetworkcontroller_dev_db\`.\`applicationsettings\` WHERE AppProperty='api_password' \\G" | /bin/grep "AppValue:")"
API_PASSWORD=${API_PASSWORD//"AppValue: "/}

echo "Username/Password: $API_USERNAME/$API_PASSWORD"

#get/loop units

#--- 762 units ---

#get target id
TargetId="$(/usr/bin/mysql -u root -e "SELECT globalproductlistsavedID FROM \`muxlabnetworkcontroller_dev_db\`.\`globalproductlistsaved\` WHERE ProductSupported_ProductSupportedID=5 \\G" | /bin/grep "globalproductlistsavedID:")"
TargetId=${TargetId//"globalproductlistsavedID: "/}

echo "TargetId: $TargetId"

mysql -u root --skip-column-names -e "SELECT \`Mac\`,\`scheduled_ir_toggle\`,\`scheduled_reboot\` FROM \`muxlabnetworkcontroller_dev_db\`.\`persistentsettings_p5\` where \`scheduled_ir_toggle\` = 1 or \`scheduled_reboot\` = 1;" | 
while read -r Mac schedules_ir_toggle scheduled_reboot; do
    echo "Mac: $Mac, schedules_ir_toggle: $schedules_ir_toggle, scheduled_reboot: $scheduled_reboot"

    #run ir curl commands

    if ((schedules_ir_toggle == 1)); then
        echo "Mac: $Mac"

        IrMode="$(/usr/bin/mysql -u root -e "SELECT ProductIoAttrIsIrMode FROM \`muxlabnetworkcontroller_dev_db\`.\`productioattributslist_p5\` WHERE ProductIoAttrMac='$Mac' \\G" | /bin/grep "ProductIoAttrIsIrMode:")"
        IrMode=${IrMode//"ProductIoAttrIsIrMode: "/}

        IrModeToggle=1
        if ((IrMode == 1)); then
            IrModeToggle=2            
        fi
        
        echo "IrMode: $IrMode"

        #TargetId=1
        #IrMode=1

        # Emitter: {"p_targetId":1,"p_cmd":"update_devices","p_data":[{"irMode":"2","modifCount":1,"mac":"00-0B-78-00-9B-F3"}]}
        # Sensor: {"p_targetId":1,"p_cmd":"update_devices","p_data":[{"irMode":"1","modifCount":1,"mac":"00-0B-78-00-9B-F3"}]}        
        #curl -i -X POST -H "Content-Type: application/json" -d "{\"p_userName\":\"$API_USERNAME\",\"p_password\":\"$API_PASSWORD\",\"p_cmd\":\"get_devices\",\"p_targetId\":1}" "http://localhost/mnc/secure_api.php"  > /dev/null 2>&1
                
        curl -i -X POST -H "Content-Type: application/json" -d "{\"p_userName\":\"$API_USERNAME\",\"p_password\":\"$API_PASSWORD\",\"p_targetId\":$TargetId,\"p_cmd\":\"update_devices\",\"p_data\":[{\"irMode\":\"$IrModeToggle\",\"modifCount\":1,\"mac\":\"$Mac\"}]}" "http://localhost/mnc/secure_api.php"
        sleep 10

        curl -i -X POST -H "Content-Type: application/json" -d "{\"p_userName\":\"$API_USERNAME\",\"p_password\":\"$API_PASSWORD\",\"p_targetId\":$TargetId,\"p_cmd\":\"update_devices\",\"p_data\":[{\"irMode\":\"$IrMode\",\"modifCount\":1,\"mac\":\"$Mac\"}]}" "http://localhost/mnc/secure_api.php"
        sleep 10            
    fi
done

#cleanup
rm -f "$LOCK_FILE"

echo ""
echo "$0> Done."
exit 0
